package testinterface;
// Interfata Functionala (Functioanl Interface)

interface Operation {
    int sum(int a, int b);
}

public class TestLambda {
    public static void main(String[] args) {
        // se creaza o INSTANTA anonima care implementeaza ingerfata Operations
        Operation op1 = new Operation() {
            public int sum(int a, int b) {
                return a + b;
            }
        };
        System.out.println(op1.sum(20, 50));
        
        // Definim o expresie Lamabda cu numele op2
        Operation op2 = (a, b) -> {return a + b;};
        // se creaza un nou OBIECT ANONIM, care contine metoda 
        // sum
        System.out.println(op2.sum(10, 10));
        
        // Definim o expresie Lamabda cu numele op2
        Operation op3 = (a, b) -> a + b;
        
        // se creaza un nou OBIECT ANONIM, care contine metoda 
        // sum
        System.out.println(op3.sum(10, 10));
    }
}
